diff --git a/amixer/amixer.c b/amixer/amixer.c
index 9d2855d..99160be 100644
--- a/amixer/amixer.c
+++ b/amixer/amixer.c
@@ -1122,6 +1122,8 @@ static int parse_control_id(const char *str, snd_ctl_elem_id_t *id)
 				}
 			}
 			*ptr = '\0';
+			if (ptr == buf)
+				return -EINVAL;
 			snd_ctl_elem_id_set_name(id, buf);
 		} else if (!strncasecmp(str, "index=", 6)) {
 			str += 6;
@@ -1145,7 +1147,13 @@ static int parse_control_id(const char *str, snd_ctl_elem_id_t *id)
 			if (*str)
 				return -EINVAL;
 		}
-	}			
+	}
+	if (*(str-1) == ',')
+		return -EINVAL;
+	if (numid > 0)
+		return 0;
+	if (size == 0)
+		return -EINVAL;
 	return 0;
 }
